using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CsNetAp
{
    public partial class Form1 : Form
    {
        private NonCodeNet.NonCodeClass objNonCode = new NonCodeNet.NonCodeClass();    // R[h/ϊIuWFNg
        private String strOutCode;                                                     // o͕R[h

        public Form1()
        {
            InitializeComponent();
        }

        // SJISւ̕ϊ
        private void Button1_Click(object sender, EventArgs e)
        {
            strOutCode = "SJIS";
            TextCodeChg();
        }

        // JISւ̕ϊ
        private void Button2_Click(object sender, EventArgs e)
        {
            strOutCode = "JIS";
            TextCodeChg();
        }

        // EUCւ̕ϊ
        private void Button3_Click(object sender, EventArgs e)
        {
            strOutCode = "EUC";
            TextCodeChg();
        }

        // UNICODEւ̕ϊ
        private void Button4_Click(object sender, EventArgs e)
        {
            strOutCode = "UNICODE";
            TextCodeChg();
        }

        // UTF7ւ̕ϊ
        private void Button5_Click(object sender, EventArgs e)
        {
            strOutCode = "UTF7";
            TextCodeChg();
        }

        // UTF8ւ̕ϊ
        private void Button6_Click(object sender, EventArgs e)
        {
            strOutCode = "UTF8";
            TextCodeChg();
        }

        private void TextCodeChg()
        {
            System.IO.Stream sr = null;
            System.IO.Stream sw = null;
            System.IO.BinaryReader br = null;
            System.IO.BinaryWriter bw = null;
            try
            {
                // ̓t@CoCi`œ
                String AppPath = System.AppDomain.CurrentDomain.BaseDirectory;
                sr = System.IO.File.Open(AppPath + "TestUtf8.txt", System.IO.FileMode.Open, System.IO.FileAccess.Read);
                br = new System.IO.BinaryReader(sr);
                byte[] dat = new byte[sr.Length];
                br.Read(dat, 0, dat.Length);

                // R[h(blnBin=oCi薳)
                String cod = objNonCode.GetCodeName(ref dat, /*blnBin:=*/false);

                // 肵R[hString(UNICODE)ɕϊ
                String uni;
                switch(cod)
                {
                    case "SJIS":
                        // SJISUNICODEւ̕ϊ
                        uni = objNonCode.SJIS_To_VbUnicode(ref dat);
                        break;
                    case "JIS":
                        // JISUNICODEւ̕ϊ
                        uni = objNonCode.JIS_To_VbUnicode(ref dat);
                        break;
                    case "EUC":
                        // EUCUNICODEւ̕ϊ
                        uni = objNonCode.EUC_To_VbUnicode(ref dat);
                        break;
                    case "UNICODE":
                        // UNICODEUNICODEւ̕ϊ
                        uni = objNonCode.UNICODE_To_VbUnicode(ref dat);
                        break;
                    case "UTF7":
                        // UTF-7UNICODEւ̕ϊ
                        uni = objNonCode.UTF7_To_VbUnicode(ref dat);
                        break;
                    case "UTF8":
                        // UTF-8UNICODEւ̕ϊ
                        uni = objNonCode.UTF8_To_VbUnicode(ref dat);
                        break;
                    case "BIN":
                        // SJISUNICODEւ̕ϊ
                        uni = objNonCode.SJIS_To_VbUnicode(ref dat);
                        break;
                    default:
                        // SJISUNICODEւ̕ϊ
                        uni = objNonCode.SJIS_To_VbUnicode(ref dat);
                        break;
                }

                // String(UNICODE)o͂R[hBytezɕϊ
                cod = strOutCode;
                switch(cod)
                {
                    case "SJIS":
                        // SJISUNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_SJIS(uni);
                        break;
                    case "JIS":
                        // JISUNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_JIS(uni);
                        break;
                    case "EUC":
                        // EUCUNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_EUC(uni);
                        break;
                    case "UNICODE":
                        // UNICODEUNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_UNICODE(uni, false);
                        break;
                    case "UTF7":
                        // UTF-7UNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_UTF7(uni);
                        break;
                    case "UTF8":
                        // UTF-8UNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_UTF8(uni, false);
                        break;
                    default:
                        // SJISUNICODEւ̕ϊ
                        dat = objNonCode.VbUnicode_To_SJIS(uni);
                        break;
                }

                // o̓t@CoCi`ŏo
                sw = System.IO.File.Open(AppPath + "TestOut.txt", System.IO.FileMode.Create, System.IO.FileAccess.Write);
                bw = new System.IO.BinaryWriter(sw);
                bw.Write(dat);
            }
            catch(Exception  ex)
            {
                throw ex;
            }
            finally
            {
                // t@C̃N[Y
                if (br != null) br.Close();
                if (sr != null) sr.Close();
                if (bw != null) bw.Close();
                if (sw != null) sw.Close();
            }
        }
    }
}